Bug 109054 - c.a.runtime.Script should verify DB transaction committed (Was: Unable to create a new content item)
c.a.runtime.Script should verify DB transaction committed (Was: Unable to cre...
Status: CLOSED WONTFIX
Product: Red Hat Enterprise CMS
Classification: Retired
Component: other (Show other bugs)
nightly
All Linux
medium Severity medium
: ---
: ---
Assigned To: ccm-bugs-list
Jon Orris
:
Depends On:
Blocks: 111508
  Show dependency treegraph
 
Reported: 2003-11-04 12:53 EST by Daniel Berrange
Modified: 2007-04-18 12:59 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2006-09-02 13:27:51 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Daniel Berrange 2003-11-04 12:53:06 EST
Description of problem:

I am currently unable to create a new content item or folder in CMS.
Upon submitting the 'New Item' / 'New Folder' forms, the browser hangs
indefinitely.

On Oracle, the last query logged in developer support is:

-- ID: #48
-- Duration: 2ms
update cms_items
set ancestors = '61/1307/1306/'
where cms_items.item_id = '1306';

Looking in v$sql, shows an entry for

  update cms_items set ancestors = :1 where cms_items.item_id = :2

Which matches.

On PostgreSQL, the last entry in developer support is


insert into vcx_obj_changes
(obj_id, txn_id, id)
values
('com.arsdigita.cms.contenttypes.Agenda;id:1:9001', '28', '901');

But oddly this *doesn't* match what's in pg_stat_activity:

insert into vcx_operations
(id, change_id, attribute, event_type_id, class_id, subtype)
values
(902, 901, 'com.arsdigita.cms.contenttypes.Agenda', 1, 12, 1)



Version-Release number of selected component (if applicable):


How reproducible:

I can reproduce it 100% on Oracle/PG with 'New Item' or 'New Folder',
others can't :-(

Steps to Reproduce:
1. Go to contet section
2. Choose 'agenda' & submit 
3. Enter title & name & submit
  
Actual results:

Hangs

Expected results:
Creates item

Additional info:
Comment 1 Jon Orris 2003-11-04 16:49:39 EST
Vadim, can you try to reproduce if possible? If it affects you, you
should run into it in the course of fixing whatever you're working on.
Comment 2 Richard Li 2003-11-04 17:48:49 EST
scott can't reproduce it with oracle/resin/ibm jdk1.3.
Comment 3 Randy Graebner 2003-11-04 17:56:38 EST
I cannot reproduce it with oracle 9.2.0.1/resin/ibm jdk 1.3 and RH 7.3
Comment 4 Jon Orris 2003-11-04 18:10:59 EST
Unable to reproduce. So far have attempted:

RH 8 2.4.20-20.8
 DBS:
  Postgres 7.3.3
  Oracle 9.2.0.2
 JVMS:
  Java(TM) 2 Runtime Environment, Standard Edition (build 1.4.2-b28)
  Java(TM) 2 Runtime Environment, Standard Edition (build 1.3.1)
  Classic VM (build 1.3.1, J2RE 1.3.1 IBM build cxia32131-20030618
(JIT  enabled: jitc))

RHEL 2.1  2.4.9-e.16
 DBS:
  Postgres 7.3.3
  Oracle 9.2.0.2
 JVMS:
  Java(TM) 2 Runtime Environment, Standard Edition (build 1.3.1)
  Classic VM (build 1.3.1, J2RE 1.3.1 IBM build cxia32131-20030329
(JIT enabled: jitc))
Comment 5 Vadim Nasardinov 2003-11-04 21:37:02 EST
I can create an Article in the "content" content section.

| $ java -version
| java version "1.3.1_09"
| Java(TM) 2 Runtime Environment, Standard Edition (build 1.3.1_09-b03)
| Java HotSpot(TM) Client VM (build 1.3.1_09-b03, mixed mode)
| $ rpm -q postgresql-server
| postgresql-server-7.2.3-5.80
Comment 6 Daniel Berrange 2003-11-05 04:39:31 EST
Ok, I'm going to strip my server right back to just include core, cms
& agenda (ie removing all the APLAWS apps), to try & isolate the
problem. Don't bother spending more time trying to reproduce until I
find more useful information.
Comment 7 Daniel Berrange 2003-11-05 13:20:49 EST
The problem turned out to be an Initializer which didn't explicitly
commit the transaction after doing some DB work. THus when time came
to create an item, the DB would block the SQL for creating the item,
until the initializer threads' DB connection had committed.

This isn't a problem when the running of the initializers was lazily
started when the first request arrived, but I add 'load-on-startup'
flag to the web.xml to get around some dodgy edge cases with lazy
initialization.

Recommendation: c.a.runtime.Startup should commit (or, abort, or throw
Exception?) if an initializer fails to close a DB transaction before
allowing control to return from init() events.
Comment 8 Richard Li 2003-11-06 11:15:25 EST
retargeting for rc0 since no longer blocker
Comment 9 Daniel Berrange 2003-11-07 05:20:08 EST
Altering summary to relect the cause of the problem & downgrading
severity.
Comment 10 Daniel Berrange 2006-09-02 13:27:51 EDT
Closing old tickets

Note You need to log in before you can comment on or make changes to this bug.